import pandas
import joblib
import treetaggerwrapper
tagger = treetaggerwrapper.TreeTagger(TAGLANG='sk')

def daj_lema_tag(veta):
    #print("Analyzujem: " + veta)
    
    veta = veta.replace("\n", "")
    veta = veta.replace("\r", "")
    
    tags = tagger.tag_text(veta)
    
    lema = ""
    tagy = ""    
    slovicko = ""
    for slovo in tags:
        if(slovo.count('\t')>1):
            slovo_info = slovo.split('\t')
            lema += slovo_info[2]+" "
            tagy += slovo_info[1]+" "
            slovicko += slovo_info[0]+" "
    return slovicko, lema, tagy

def generuj_skupiny(text):
    tagy = text.split(" ")
    vystup = ''
    for jeden_tag in tagy:
        tag = jeden_tag.strip()    
        if (tag != '' and tag != 'SENT'):
            vystup += tag[0] + ' '
        if (len(tag)>1 and tag != 'SENT'):
            for i, c in enumerate(tag):
                if(i != 0):
                    kolko = ''
                    for j in range(1,i):
                        kolko += '_'
                    novy = tag[0]+kolko+c
                    vystup += novy + ' '
    return vystup

def rataj_tagy(tagy,co,pocet_vsetkych):
    vysledok = 0
    if type(tagy) == str:
        tagy = ' ' + tagy
        #medzere musia tu byť dve       
   #     pocet_vsetkych = spolu+1
        if pocet_vsetkych == 0:
            pocet_vsetkych = 1
        vysledok = tagy.count(co)/pocet_vsetkych
    #print('.')
    return vysledok

tagy = []
#with open("list_all.txt", "r") as f:
with open("list_all.txt", "r") as f:
  for line in f:
    tagy.append(line.strip())
    
filename = 'model_all.sav'
model = joblib.load(filename)

vstup = input('Vložte text správy:')
print('')
print('- Identifikácia morfologických značiek...')
v, l, t = daj_lema_tag(vstup)
print('')
print('- Identifikované značky: ' + t)
mnozina_tagov = t.split(" ")
pocet_slov = len(mnozina_tagov) - 1
print('')
print('- Vytváranie vstupného vektoru...')

vstupne_tagy = generuj_skupiny(t)
vzor = pandas.DataFrame(columns=[])

for jeden_tag in tagy:
    if jeden_tag!= "":
        hladaj = jeden_tag+' '
        kolko = rataj_tagy(vstupne_tagy,hladaj,pocet_slov)
    #    print(kolko)
    #    if(parameter == ''):
    #        parameter = parameter + jeden_tag + ':'+str(kolko)
    #    else:
    #       parameter = parameter + ',' + jeden_tag + ':'+str(kolko)
        # vzor[jeden_tag] = kolko
        vzor[jeden_tag] = 'ewe'
        vzor.loc[0,jeden_tag] = kolko
        # vzor[jeden_tag] = vzor.apply(lambda row: kolko, axis=1)
#vzor = pandas.DataFrame([{parameter}])
print('')
print('Vstupný vektor:   ')
print(vzor.to_string())
print('')
print('- Načítanie klasifikátora...')
print('')
print('- Vytvorenie predikcie...')
print('')
print('')
y_pred = model.predict(vzor)

if (y_pred == 'real'):
    print('Správa bola klasifikovaná ako PRAVDIVÁ.')
else:
    print('Správa bola klasifikovaná ako FALOŠNÁ.')

# print(y_pred)
#print('')
#print('Pravdepodobnosť, že správa je falošná je '+str((y_pred[0]*10)/2)+'% ')