import pandas
import joblib
import treetaggerwrapper
tagger = treetaggerwrapper.TreeTagger(TAGLANG='sk')

def daj_lema_tag(veta):
    #print("Analyzujem: " + veta)
    
    veta = veta.replace("\n", "")
    veta = veta.replace("\r", "")
    
    tags = tagger.tag_text(veta)
    
    lema = ""
    tagy = ""    
    slovicko = ""
    for slovo in tags:
        if(slovo.count('\t')>1):
            slovo_info = slovo.split('\t')
            lema += slovo_info[2]+" "
            tagy += slovo_info[1]+" "
            slovicko += slovo_info[0]+" "
    return slovicko, lema, tagy

def tag_prvy_plus_kolky(veta,poradie):
    v, l, t = daj_lema_tag(veta)
    vysledok = ""
    tagy = t.split(" ")
    for tag in tagy:
        if(tag!='SENT'):
            if(tag!=""):
                if(len(tag)>=poradie):
                    vysledok += tag[0]+tag[poradie-1] + ' '
                else:
                    vysledok += tag[0]+ ' '
    return vysledok

def to_tags(row):
    text = row
    vysledok = " "
    if text =="":
        return ""
    else:
        vysledok = tag_prvy_plus_kolky(text,2)
        return vysledok

def to_n_gram(text):
    #text = row
    vysledok = " "
    if (text == ""):
        return ""
    else:
        pole = text.split(' ');
        for i in range(0, len(pole)-1):
            vysledok = vysledok +pole[i]+'~~'+pole[i+1]+' '
        return vysledok

def rataj_tagy(tagy,co):
    vysledok = 0
    if type(tagy) == str:
        #medzere musia tu byť dve       
        pocet_vsetkych = tagy.count(' ')
        if pocet_vsetkych == 0:
            pocet_vsetkych = 1
        vysledok = tagy.count(co)/pocet_vsetkych
   # print('.')
    return vysledok

tagy = []
#with open("list_all.txt", "r") as f:
with open("list_2_gram_reg.txt", "r") as f:
  for line in f:
    tagy.append(line.strip())
    
filename = 'model_n_gram_reg.sav'
model = joblib.load(filename)

vstup = input('Vložte text správy:')
print('')
print('- Identifikácia morfologických značiek...')
veta_tagy = to_tags(vstup)
print('')
print('- Identifikované značky: ' + veta_tagy)

print('')
print('- Tvorba 2-gramov.... ')
dvoj_gramy = to_n_gram(veta_tagy)
print('- Identifikované 2-gramy: ' + dvoj_gramy)

#mnozina_tagov = t.split(" ")
#pocet_slov = len(mnozina_tagov) - 1
print('')
print('- Vytváranie vstupného vektoru...')

#vstupne_tagy = generuj_skupiny(t)
vzor = pandas.DataFrame(columns=[])

for jeden_tag in tagy:
    if jeden_tag!= "":
        hladaj = jeden_tag+' '
        kolko = rataj_tagy(dvoj_gramy,hladaj)
    #    print(kolko)
    #    if(parameter == ''):
    #        parameter = parameter + jeden_tag + ':'+str(kolko)
    #    else:
    #       parameter = parameter + ',' + jeden_tag + ':'+str(kolko)
        # vzor[jeden_tag] = kolko
        vzor[jeden_tag] = 'ewe'
        vzor.loc[0,jeden_tag] = kolko
        # vzor[jeden_tag] = vzor.apply(lambda row: kolko, axis=1)
#vzor = pandas.DataFrame([{parameter}])
print('')
#print('Vstupný vektor: ')
#print(vzor.to_string())
print('')
print('- Načítanie klasifikátora...')
print('')
print('- Vytvorenie predikcie...')

y_pred = model.predict(vzor)
print()
print('')
print('Pravdepodobnosť, že správa je falošná je '+str((y_pred[0]*10)/2)+'% ')